--
-- Created by: BadLuckBurt
-- Date: 5/3/15
-- Time: 6:48 PM
--

local playerTile = {}

playerTile.width = 64
playerTile.height = 64
playerTile.scaleX = 1
playerTile.scaleY = 1
playerTile.x = 0
playerTile.y = 0
playerTile.maxX = 0
playerTile.maxY = 0
playerTile.canvas = nil

function playerTile:createCanvas(bDraw)
	self.canvas = love.graphics.newCanvas(self.width, self.height)
	if bDraw == true then self:draw() end
end

function playerTile:render()
	love.graphics.draw(self.canvas, self.x, self.y, 0, self.scaleX, self.scaleY, 0, 0, 0, 0)
end

function playerTile:draw()
	-- Set the canvas for drawing
	love.graphics.setCanvas(self.canvas)
	-- draw colored square to canvas
	love.graphics.setColor(230,240,120)
	love.graphics.rectangle('fill',0,0,self.width,self.height)
	love.graphics.setCanvas()
end

function playerTile:calcMovement(dtPixelStep, keymap)
	if keymap.upPressed == true then
		self.y = math.max(0, self.y - dtPixelStep)
	elseif keymap.downPressed == true then
		self.y = math.min(self.maxY, self.y + dtPixelStep)
	end

	if keymap.rightPressed == true then
		self.x = math.min(self.maxX, self.x + dtPixelStep)
	elseif keymap.leftPressed == true then
		self.x = math.max(0, self.x - dtPixelStep)
	end
end

function playerTile:calcMax(x, y)
	self.maxX = x - (self.width * self.scaleX)
	self.maxY = y - (self.height * self.scaleY)
end

return playerTile