--
-- Created by: BadLuckBurt
-- Date: 5/3/15
-- Time: 6:02 PM
--

local tilemapGenerator = {}

tilemapGenerator.tileWidth = 16
tilemapGenerator.tileHeight = 16
tilemapGenerator.x = nil
tilemapGenerator.y = nil

function tilemapGenerator:generateWater(bFillAll)
	local waterMap = {}
	waterMap.tiles = {}
	local x = 1
	local y = 1
	local bAddTile = false
	for y=1,self.y,1 do
		waterMap.tiles[y] = {}
		for x=1,self.x,1 do
			bAddTile = self:addTile(x, y)
			if bFillAll == true or bAddTile == true then
				waterMap.tiles[y][x] = "water"
			else
				waterMap.tiles[y][x] = ""
			end

		end
	end
	waterMap.tileWidth = self.tileWidth
	waterMap.tileHeight = self.tileHeight
	waterMap.width = self.x * self.tileWidth
	waterMap.height = self.y * self.tileHeight
	return waterMap
end

function tilemapGenerator:addTile(x, y)
	local fAdd = love.math.random()
	local bAddTile = false
	if fAdd > 0.75 then
		bAddTile = true
	end
	return bAddTile
end

function tilemapGenerator:setDimensions(width, height)
	self.x = width / self.tileWidth
	self.y = height / self.tileHeight
end

return tilemapGenerator